package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.OrgSector;
import com.sa.ibiz.demo.demo.domain.OrgUser;
import com.sa.ibiz.demo.demo.domain.OrgUser;

/**
 * 实体[XM] 数据对象
 */
@TableName(value = "T_XM",resultMap = "XMResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class XM extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private OrgSector fzbm;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private OrgUser fzr;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private OrgUser zxr;
    private String bz;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String fj;
    private String fzbmid;
    private String fzrid;
    private Timestamp qdsj;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "xmid",type=IdType.UUID)//指定主键生成策略
    private String xmid;
    private Double xmje;
    private String xmname;
    private String xmzq;
    private String zxrid;
    /**
     *  设置属性值[备注]
     *  @param bz
     */
    public void setBz(String bz){
        if(StringUtils.isEmpty(bz))
            bz=null;
        this.bz = bz;
        this.set("bzdirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getBz(){
        return this.bz;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetBz(){
        this.set("bzdirtyflag",false);
        this.bz = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[附件]
     *  @param fj
     */
    public void setFj(String fj){
        if(StringUtils.isEmpty(fj))
            fj=null;
        this.fj = fj;
        this.set("fjdirtyflag",true);
    }
    /**
     *  获取属性值[附件]
     */
    public String getFj(){
        return this.fj;
    }
    /**
     *  重置属性值[附件]
     */
    public void resetFj(){
        this.set("fjdirtyflag",false);
        this.fj = null;
    }
    /**
     *  设置属性值[负责部门]
     *  @param fzbmid
     */
    public void setFzbmid(String fzbmid){
        if(StringUtils.isEmpty(fzbmid))
            fzbmid=null;
        this.fzbmid = fzbmid;
        this.set("fzbmiddirtyflag",true);
    }
    /**
     *  获取属性值[负责部门]
     */
    public String getFzbmid(){
        return this.fzbmid;
    }
    /**
     *  重置属性值[负责部门]
     */
    public void resetFzbmid(){
        this.set("fzbmiddirtyflag",false);
        this.fzbmid = null;
    }
    /**
     *  设置属性值[负责人]
     *  @param fzrid
     */
    public void setFzrid(String fzrid){
        if(StringUtils.isEmpty(fzrid))
            fzrid=null;
        this.fzrid = fzrid;
        this.set("fzriddirtyflag",true);
    }
    /**
     *  获取属性值[负责人]
     */
    public String getFzrid(){
        return this.fzrid;
    }
    /**
     *  重置属性值[负责人]
     */
    public void resetFzrid(){
        this.set("fzriddirtyflag",false);
        this.fzrid = null;
    }
    /**
     *  设置属性值[项目启动时间]
     *  @param qdsj
     */
    public void setQdsj(Timestamp qdsj){
        this.qdsj = qdsj;
        this.set("qdsjdirtyflag",true);
    }
    /**
     *  获取属性值[项目启动时间]
     */
    public Timestamp getQdsj(){
        return this.qdsj;
    }
    /**
     *  重置属性值[项目启动时间]
     */
    public void resetQdsj(){
        this.set("qdsjdirtyflag",false);
        this.qdsj = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[项目标识]
     *  @param xmid
     */
    public void setXmid(String xmid){
        if(StringUtils.isEmpty(xmid))
            xmid=null;
        this.xmid = xmid;
        this.set("xmiddirtyflag",true);
    }
    /**
     *  获取属性值[项目标识]
     */
    public String getXmid(){
        return this.xmid;
    }
    /**
     *  重置属性值[项目标识]
     */
    public void resetXmid(){
        this.set("xmiddirtyflag",false);
        this.xmid = null;
    }
    /**
     *  设置属性值[项目金额]
     *  @param xmje
     */
    public void setXmje(Double xmje){
        this.xmje = xmje;
        this.set("xmjedirtyflag",true);
    }
    /**
     *  获取属性值[项目金额]
     */
    public Double getXmje(){
        return this.xmje;
    }
    /**
     *  重置属性值[项目金额]
     */
    public void resetXmje(){
        this.set("xmjedirtyflag",false);
        this.xmje = null;
    }
    /**
     *  设置属性值[项目名称]
     *  @param xmname
     */
    public void setXmname(String xmname){
        if(StringUtils.isEmpty(xmname))
            xmname=null;
        this.xmname = xmname;
        this.set("xmnamedirtyflag",true);
    }
    /**
     *  获取属性值[项目名称]
     */
    public String getXmname(){
        return this.xmname;
    }
    /**
     *  重置属性值[项目名称]
     */
    public void resetXmname(){
        this.set("xmnamedirtyflag",false);
        this.xmname = null;
    }
    /**
     *  设置属性值[项目周期]
     *  @param xmzq
     */
    public void setXmzq(String xmzq){
        if(StringUtils.isEmpty(xmzq))
            xmzq=null;
        this.xmzq = xmzq;
        this.set("xmzqdirtyflag",true);
    }
    /**
     *  获取属性值[项目周期]
     */
    public String getXmzq(){
        return this.xmzq;
    }
    /**
     *  重置属性值[项目周期]
     */
    public void resetXmzq(){
        this.set("xmzqdirtyflag",false);
        this.xmzq = null;
    }
    /**
     *  设置属性值[执行人]
     *  @param zxrid
     */
    public void setZxrid(String zxrid){
        if(StringUtils.isEmpty(zxrid))
            zxrid=null;
        this.zxrid = zxrid;
        this.set("zxriddirtyflag",true);
    }
    /**
     *  获取属性值[执行人]
     */
    public String getZxrid(){
        return this.zxrid;
    }
    /**
     *  重置属性值[执行人]
     */
    public void resetZxrid(){
        this.set("zxriddirtyflag",false);
        this.zxrid = null;
    }
     /**
     *  获取主实体关联数据[OrgSector]
     */
    public OrgSector getFzbm() {
        return fzbm;
    }
    /**
     *  设置主实体关联数据[OrgSector]
     */
    public void setFzbm(OrgSector fzbm) {
        this.fzbm = fzbm;
    }

     /**
     *  获取主实体关联数据[OrgUser]
     */
    public OrgUser getFzr() {
        return fzr;
    }
    /**
     *  设置主实体关联数据[OrgUser]
     */
    public void setFzr(OrgUser fzr) {
        this.fzr = fzr;
    }

     /**
     *  获取主实体关联数据[OrgUser]
     */
    public OrgUser getZxr() {
        return zxr;
    }
    /**
     *  设置主实体关联数据[OrgUser]
     */
    public void setZxr(OrgUser zxr) {
        this.zxr = zxr;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetBz();
        resetCreatedate();
        resetCreateman();
        resetFj();
        resetFzbmid();
        resetFzrid();
        resetQdsj();
        resetUpdatedate();
        resetUpdateman();
        resetXmid();
        resetXmje();
        resetXmname();
        resetXmzq();
        resetZxrid();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public XM copyTo(XM targetEntity)
	{
		BeanCopier copier=BeanCopier.create(XM.class, XM.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetXmid();
		return targetEntity;
	}
}